//---------------------------------------------------------------------------
#include <vcl.h>
#include <process.h>

#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  SetCurrentDir(ExtractFileDir(ParamStr(0)));
  //debug
/*  char *prgname;
  int retnum;
  prgname = "md-pri.exe";
  retnum = spawnl(P_WAIT, prgname, prgname, "temp.in", NULL);  */
  //end debug
}//end TForm1::TForm1
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonCalcClick(TObject *Sender)
{
  AnsiString ForInFile, buffer, destname;
  ForInFile = EditNick->Text + "\r\n" + EditDate->Text + "\r\n";
  ForInFile = ForInFile + EditTime->Text + "\r\n";
  ForInFile = ForInFile + EditTimezone->Text + "\r\n";
  ForInFile = ForInFile + EditCity->Text + "\r\n";
  ForInFile = ForInFile + EditShirota->Text + "\r\n";
  ForInFile = ForInFile + EditDolgota->Text + "\r\n";
  ForInFile = ForInFile + EditMonths->Text + "\r\n";
  buffer = CheckBoxProgressii->Checked ? "p" : "a";
  ForInFile = ForInFile + buffer + "\r\n";
  ForInFile = ForInFile + "temp.out\r\n";
  //test.in content created
  destname = "temp.in";
  int handle;
  AnsiString TempFN;
  try
  {
    handle=FileCreate(destname);
    FileWrite(handle,
              ForInFile.c_str(),
              ForInFile.Length());  //save to temporary file
    FileClose(handle);
  }
  catch (Exception &exception)
  {
   TempFN = (AnsiString)"   :\n" + destname;
   Application->MessageBox(
    TempFN.c_str(),
    "!!!",
    MB_OK | MB_ICONERROR);
   return;
  }
  char *prgname;
  int retnum;
  prgname = "md-pri.exe";
  retnum = spawnl(P_WAIT, prgname, prgname, "temp.in", NULL);
  if (retnum!=0)
  {
    TempFN = (AnsiString)"  :\n" + prgname;
    Application->MessageBox(
      TempFN.c_str(),
      "!!!",
      MB_OK | MB_ICONERROR);
    return;
  }
  WhatInOut = SpacesToDotsXe(LoadTheFile("temp.out"));
  Form2->ShowModal();
}//end TForm1::ButtonCalcClick
//---------------------------------------------------------------------------

AnsiString LoadTheFile(AnsiString FName)
{
 int file_handle, file_size;
 char *buf;
 AnsiString ret;
 try
 {
        file_handle=FileOpen(FName,
                             fmOpenRead);
        file_size=FileSeek(file_handle,
                           0,
                           2);
        FileSeek(file_handle,
                           0,
                           0);
        buf = new char [file_size+1];
        buf[file_size]=0;
        FileRead(file_handle,
                 buf,
                 file_size);
        FileClose(file_handle);
        //Today=true;
        ret=buf;
        delete [] buf;
 }
 catch (Exception &exception)
 {
  ret=(AnsiString)"    "+FName;
  Application->MessageBox(
        "  ",
        FName.c_str(),
        MB_OK | MB_ICONERROR);
 }
 return ret;
}//end LoadTheFile

AnsiString SpacesToDotsXe(AnsiString src)
{
  char *pntr, tmpbuf[2];
  int len, i, nS;
  AnsiString ret;
  pntr = src.c_str();
  len = src.Length();
  i = 0;
  tmpbuf[1] = (char)0;
  nS = 0;  //number of LFs
  while (i < len)
  {
    //
    if ((pntr[i] == '\n')&&(nS < 2))
      nS++;
    if (pntr[i] == ' ')
    {
      if (nS > 1)
        tmpbuf[0] = '.';
      else
        tmpbuf[0] = pntr[i];
    }
    else
      tmpbuf[0] = pntr[i];
    ret = ret + tmpbuf;
    i++;
  }//end while
  return ret;
}//end SpacesToDotsXe
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonNewClick(TObject *Sender)
{
  //new project
  int MBoxRet;
  bool DoIt=false;
  MBoxRet = Application->MessageBox("  ?",
      "  ", MB_ICONQUESTION | MB_YESNOCANCEL);
  if (MBoxRet==IDYES)
  {
    DoIt=true;
    if (EditFilename->Text.IsEmpty())
      SpeedButtonSaveAsClick(this);
    else
      SpeedButtonSaveClick(this);
  }
  if (MBoxRet==IDCANCEL) { DoIt=false; }
  if (MBoxRet==IDNO) { DoIt=true; }
  // 
  if (DoIt)
  {
    EditNick->Clear();
    EditDate->Clear();
    EditTime->Clear();
    //EditTimezone->Clear();
    EditTimezone->Text = "3";
    EditCity->Clear();
    EditShirota->Clear();
    EditDolgota->Clear();
    EditMonths->Clear();
    CheckBoxProgressii->Checked = false;
    EditFilename->Text = "";
  }
}//end TForm1::SpeedButtonNewClick
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonOpenClick(TObject *Sender)
{
  //open project
  TIniFile *IniFile;
  AnsiString TheFileName, thename2/*, value*/;
  if (OpenDialog1->Execute())
  {
    EditFilename->Text = OpenDialog1->FileName;
  }
  else
    return;
  thename2 = ExtractFileDir(EditFilename->Text);
  if (thename2.IsEmpty())
  {
    TheFileName = ExtractFileDir(ParamStr(0));
    TheFileName = TheFileName + "\\" + EditFilename->Text;
  }
  else
    TheFileName = EditFilename->Text;
  //debug
  //Application->MessageBox(TheFileName.c_str(), "Debug", MB_OK);
  //end debug
  try
  {
    IniFile = new TIniFile(TheFileName);
    EditNick->Text = IniFile->ReadString("data", "nick", "");
    EditDate->Text = IniFile->ReadString("data", "date", "");
    EditTime->Text = IniFile->ReadString("data", "time", "");
    EditTimezone->Text = IniFile->ReadString("data", "timezone", "");
    EditCity->Text = IniFile->ReadString("data", "city", "");
    EditShirota->Text = IniFile->ReadString("data", "shirota", "");
    EditDolgota->Text = IniFile->ReadString("data", "dolgota", "");
    EditMonths->Text = IniFile->ReadString("data", "months", "");
    CheckBoxProgressii->Checked = IniFile->ReadBool("data", "progressii", false);
    IniFile->UpdateFile();
    delete IniFile;
  }
  catch (...)
  {
    Application->MessageBox("   !",
        "SM MoonLine", MB_OK | MB_ICONERROR);
    return;
  }
  Application->MessageBox(TheFileName.c_str(), ".  ", MB_OK);
  EditFilename->Text = TheFileName;
}//end TForm1::SpeedButtonOpenClick
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonSaveClick(TObject *Sender)
{
  //save current project
if (EditFilename->Text.IsEmpty())
    SpeedButtonSaveAsClick(this);
else
{
  TIniFile *IniFile;
  AnsiString TheFileName, thename2;
  thename2 = ExtractFileDir(EditFilename->Text);
  if (thename2.IsEmpty())
  {
    TheFileName = ExtractFileDir(ParamStr(0));
    TheFileName = TheFileName + "\\" + EditFilename->Text;
  }
  else
    TheFileName = EditFilename->Text;
  try
  {
    IniFile = new TIniFile(TheFileName);
    IniFile->WriteString("data", "nick", EditNick->Text);
    IniFile->WriteString("data", "date", EditDate->Text);
    IniFile->WriteString("data", "time", EditTime->Text);
    IniFile->WriteString("data", "timezone", EditTimezone->Text);
    IniFile->WriteString("data", "city", EditCity->Text);
    IniFile->WriteString("data", "shirota", EditShirota->Text);
    IniFile->WriteString("data", "dolgota", EditDolgota->Text);
    IniFile->WriteString("data", "months", EditMonths->Text);
    IniFile->WriteBool("data", "progressii", CheckBoxProgressii->Checked);
    IniFile->UpdateFile();
    delete IniFile;
  }
  catch (...)
  {
    Application->MessageBox("   !",
        "SM MoonLine", MB_OK | MB_ICONERROR);
    return;
  }
  Application->MessageBox("    .",
    "!", MB_OK);
}//end else
}//end TForm1::SpeedButtonSaveClick
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButtonSaveAsClick(TObject *Sender)
{
  //save project as...
  if (SaveDialog1->Execute())
  {
    EditFilename->Text = SaveDialog1->FileName;
    if (EditFilename->Text.IsEmpty())
    {
      Application->MessageBox("   !    OK?",
        "", MB_OK | MB_ICONWARNING);
      return;
    }
    else
      SpeedButtonSaveClick(this);
  }
}//end TForm1::SpeedButtonSaveAsClick
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonAboutClick(TObject *Sender)
{
  //
  AboutBox->ShowModal();
}//end TForm1::ButtonAboutClick
//---------------------------------------------------------------------------

